import requests
from db import save_ad_id, ad_id_exists, save_ad_and_photos
from config import sheypoor_categories, divar_categories
import datetime
from logging_script import logger
from bs4 import BeautifulSoup
from datetime import datetime, timezone


def last_post_date():
    now_utc = datetime.now(timezone.utc)
    iso_format_now = now_utc.isoformat(timespec='microseconds').replace('+00:00', 'Z')
    return iso_format_now


async def crawl_divar():
    url_base = "https://api.divar.ir/v8/postlist/w/search"
    

    categories = ['residential-sell', 'residential-rent', 'commercial-sell', 'commercial-rent']
    header_post = {
        "Content-Type": "text/plain",

    }
    headers ={
    "Content-Type": "application/json", 'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/34.0.1847.131 Safari/537.36'
    }
    for cat in categories:
        max_count = 6
        counter = 0
        json = {
              "city_ids": [
                "22"
              ],
              "pagination_data": {
                "@type": "type.googleapis.com/post_list.PaginationData",
                "last_post_date": last_post_date(),
                "page": 1,
                "layer_page": 1
              },
              "search_data": {
                "form_data": {
                  "data": {
                    "business-type":{"str": {"value": "personal"}},
                    "category": {
                      "str": {
                        "value": cat
                      }
                    },
                    "sort": {
                      "str": {
                        "value": "sort_date"
                      }
                    }
                  }
                }
              }
            }
   
        try:
            res = requests.post(url_base, json=json, headers=headers)
            data = res.json()
        except:
            continue
        logger.info(f" {cat} : {res.status_code}")
        count = 0
        # logger.info(data)
        for i in data["list_widgets"]:
            data = i["data"]
            token = data["action"]["payload"]["token"]
            # time.sleep(.8)
            if count > 2:
                break
            if not ad_id_exists(token) and counter < max_count:
                logger.info(f" {token} started")
                title = data["title"]
                price = data.get("middle_description_text", " ") + "\n" + data.get("top_description_text", " ") + "\n" + data.get("bottom_description_text", " ")
                photo_link = data.get("image_url", None)

                url = "https://divar.ir/v/" + token
                link = "https://api.divar.ir/v8/posts-v2/web/" + token
                address, phone = "None", "None"
                try:
                    res = requests.get(link, headers=header_post)
                    data = res.json()

                    data_post = data["sections"]
                    for i in data_post:
                        if i["section_name"]== "DESCRIPTION":
                            description = i["widgets"][1]["data"]["text"]
                        if i["section_name"]== "LIST_DATA":
                            extracted_info = []
                            for j in i["widgets"] :
                                widget_type = j.get('widget_type', '')
                                if widget_type == 'GROUP_INFO_ROW':
                                    for sub_item in j['data'].get('items', []):
                                        extracted_info.append({'title': sub_item.get('title', ''), 'value': sub_item.get('value', '')})
                                elif widget_type == 'UNEXPANDABLE_ROW':
                                    extracted_info.append({'title': j['data'].get('title', ''), 'value': j['data'].get('value', '')})

                                elif widget_type == 'GROUP_FEATURE_ROW':
                                    for sub_item in j['data'].get('items', []):
                                        extracted_info.append({'title': sub_item.get('title', ''), 'value': 'دارد' if sub_item.get('available', False) else ''})

                                elif widget_type == 'FEATURE_ROW':
                                    extracted_info.append({'title': j['data'].get('title', ''), 'value': 'دارد'})
                    description_text = ""
                    temp = ""
                    for info in extracted_info:
                        if info["value"].count("ندارد") > 1:
                            info['value'] = "ندارد"
                        temp += info['title'] + " "  + info['value'] + "\n"
                    
                    description_text = temp + description


                    if("املاک" in description_text) or ("دپارتمان" in description_text) or ("مشاور" in  description_text) or ("همکار" in description_text):
                        continue
                except:
                    description_text = ""
            

                date = ""
                


                save_ad_and_photos(token, title, address, url, price, description_text, phone, photo_link, date, '#دیوار')
                save_ad_id(token, divar_categories[cat])
                counter += 1
            else:
                count += 1



                
                




async def crawl_sheypoor():
    url = "https://www.sheypoor.com/api/v10.0.0/search/sari/"
    categories = ['houses-apartments-for-sale', 'house-apartment-for-rent', 'commercial-properties-for-sale', 'commercial-properties-for-rent', 'real-estate-services']
    headers= {'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/34.0.1847.131 Safari/537.36'}
    for cat in categories:
        max_count = 4
        counter = 0
        res = requests.get(url+cat, headers=headers)
        data = res.json()['data']
        logger.info(f" {cat} : {res.status_code}")
        count = 0
        for i in data:
            if count > 2:
                break
            if i["type"] == "normal":
                ad_id = i["id"]
                description = i['description']
                if("املاک" in description) or ("دپارتمان" in description) or ("فایل" in description) or ("مشاور" in  description) or ("همکار" in description):
                    continue
                if not ad_id_exists(ad_id) and counter < max_count:
                    logger.info(f" {ad_id} started")
                    link = i["attributes"]["url"]
                    # try:
                        # phone_url = f"https://www.sheypoor.com/api/v10.0.0/listings/{ad_id}/number"
                        # phone_res = requests.get(phone_url, headers=headers)
                        # phone = phone_res.json()['data']['attributes']['phoneNumber']
                        # logger.info(phone_res.json()['data'])
                    # except:
                        # phone = "None"
                    phone = "None"
                    try:
                        price = ""
                        for j in i["attributes"]["price"]:
                            for z in j.values():
                                price += f" {z} "
                            price += "\n"
                    except:
                        price = "None"
                    try:
                        photo_link = i["attributes"]["images"]["thumbnails"]["round"]
                    except:
                        photo_link = "None"
                    
                    try:
                        # ads_res = requests.get(link, headers=headers)
                        # ads_res.raise_for_status()
                        # soup = BeautifulSoup(ads_res.content, 'html.parser')
                        # logger.info(f" {ads_res.status_code}")
                        # div_bWPjU = soup.find('div', class_='bWPjU')
                        # h3_tags = soup.find_all('h3')
                        # logger.info(f"h3 Text :", h3_tags)
                        # for i, h3 in enumerate(h3_tags, 1):
                            # h3_text = h3.get_text(separator=' ', strip=True)
                            # logger.info(f"h3 Text {i}:", h3_text)
                        # amlak_tag = soup.find('div', class_="CaATI")
                        # logger.info(f" esm amlak1 {amlak_tag}")
                        # amlak_tag = amlak_tag.get_text(separator=' ', strip=True)
                        # logger.info(f" esm amlak2 {amlak_tag}")
                        # if ('املاک' in amlak_tag) or ('هلدینگ' in amlak_tag) or ('دپارتمان' in amlak_tag) : 
                            # continue
                        # description = div_bWPjU.get_text(separator='|', strip=True)
                        # description_list = description.split("|")
                        # description = ""
                        # for i_,j in enumerate(description_list):
                            # if i_%2==0:
                                # description += j + " : "
                            # else:
                                # description += j + "\n"
                        api_ad = "https://www.sheypoor.com/api/v10.0.0/listings/"
                        ads_res = requests.get(api_ad+ad_id, headers=headers)
                        # logger.info(ads_res.status_code)
                        # logger.info(f'yoooo {ads_res.json()["data"]["attributes"]["seller"]["name"]}')
                        temp = ads_res.json()
                        ad_seller_name = temp["data"]["attributes"]["seller"]["name"]
            
                        if ('املاک' in ad_seller_name) or ('دپارتمان' in ad_seller_name) : 
                            continue
                
                    except:
                        if len(description) > 800:
                            description = description[:800]
                        else:
                            description = description
                    
                    flag_amlak = False
                    try:
                        seller_page = requests.get(temp["data"]["attributes"]["seller"]["url"], headers=headers)
                        soup = BeautifulSoup(seller_page.content, 'html.parser')
                        main_div = soup.body.main.div.section.div
                        articles = main_div.find_all('article')
                        for article in articles:
                            divs_in_article = article.find_all('div')
                            if divs_in_article and len(divs_in_article) > 1:
                                second_div = divs_in_article[1]
                                if second_div.find('div', class_='shop-logo'):
                                    flag_amlak = True
                                    break
                    except:
                        continue

                    if flag_amlak:
                        continue



                    save_ad_and_photos(ad_id, i["attributes"]["title"], i["attributes"]["location"], link, price, description, phone, photo_link, i["attributes"]["timePassedLabel"], '#شیپور')
                    save_ad_id(ad_id, sheypoor_categories[cat])
                    counter += 1
                else:
                    count += 1
